
import edu.illinois.cs.cs125.gradlegrader.annotations.Graded;
import edu.illinois.cs.cs125.gradlegrader.annotations.Tag;
import org.junit.Test;
import java.io.PrintStream;
import java.lang.reflect.Method;
import java.io.ByteArrayOutputStream;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

public class WelcomeTests {


    @Test(timeout = 300)
    @Graded(points = 1)
    @Tag(name = "difficulty", value = "simple")
    @Tag(name = "function", value = "Welcome.main")
    public void testAufgabe1AufrufOk() {        
        try{
            runWelcomeWithArgumentAndCaptureOutput("Spock");
        } catch (Exception e) {
            fail(e.getMessage());
        }
    }


    @Test(timeout = 300)
    @Graded(points = 1)
    @Tag(name = "difficulty", value = "simple")
    @Tag(name = "function", value = "Welcome.main")
    public void testAufgabe1EnthaeltHalloUndName()  {
        try {
            String output = runWelcomeWithArgumentAndCaptureOutput("Spock");

            assertTrue("Gibt Hallo aus", output.contains("Hallo"));
            assertTrue("Gibt Spock aus", output.contains("Spock"));
        } catch (Exception e) {
            fail(e.getMessage());
        }
    }
    
    @Test(timeout = 300)
    @Graded(points = 1)
    @Tag(name = "difficulty", value = "simple")
    @Tag(name = "function", value = "Welcome.main")
    public void testAufgabe1EndetMitAusrufezeichen() throws Exception {
        try{
            String output = runWelcomeWithArgumentAndCaptureOutput("Spock");
            assertTrue("Endet mit Ausrufezeichen", output.trim().endsWith("!"));
        } catch (Exception e) {
            fail(e.getMessage());
        }
    }

    private String runWelcomeWithArgumentAndCaptureOutput(String argument) throws Exception {
        
        ByteArrayOutputStream outContent = new ByteArrayOutputStream();
        PrintStream originalOut = System.out;
        
        System.setOut(new PrintStream(outContent));       
        
        String[] args = {argument};
        
        Class<?> cls = Class.forName("Welcome");
        Method meth = cls.getMethod("main", String[].class);
        meth.invoke(null, (Object) args); 
        
        String output = outContent.toString();

        System.setOut(originalOut);
        return output;
        
    }           
}
